#ifndef __MENUS_H__
#define __MENUS_H__

/* MAJOR NOTE: As long as I have no need in dynamic menus -
 I've limited myself to safe program area space,
 but parent can point to ROM only, so I HAVE TO
 declate all menu_level structs as const !!! */
/* This saved about 54 bytes on template (early alpha) */

//For non-menu line special parameters.
#define MENU_LINE_SUBMENU 0x80
#define MENU_LINE_TOGGLE  0x40
#define MENU_LINE_END     0x0
#define NMASK 0xF
/* Pointer to menu_line_XXX, menu_level or to strings array */
    //code

#define MENU_LINE_COMM_FIELDS  \
    unsigned char flags_and_no; \
    const code char * name;

struct menu_line {
    MENU_LINE_COMM_FIELDS
};
#define MENULEVEL2PTR(a) ((const code struct menu_level *)(&a))
#define MENULINE2PTR(a) ((const code void *)(&a))
struct menu_level {
    void (*parent_call)(void); //TODO: comment why callback.

    const code void * const code * lines;
    const code char * menu_title;
    const code char * menu_title2;
    void (*printer)(void);
};
#define INST_MENU_LEVEL(a,b,c,d,e,f) \
    const code struct menu_level a = {b,c,d,e,f}

struct menu_line_toggle {
    MENU_LINE_COMM_FIELDS

    const code char * const code * strings;
    unsigned char *var_ptr;
    unsigned char arg;
};
#define ML2MLT(a) ((const code struct menu_line_toggle *)a)
#define INST_MLT(a,b,c,d,e,f) \
    const code struct menu_line_toggle a = {b | MENU_LINE_TOGGLE,c,d,e,f}

struct menu_line_sub {
    MENU_LINE_COMM_FIELDS

    const code struct menu_level *sub;
};
#define ML2MLS(a) ((const code struct menu_line_sub *)a)
#define INST_MLS(a,b,c,d) \
    const code struct menu_line_sub a = {b | MENU_LINE_SUBMENU,c,d}

struct menu_line_cb {
    MENU_LINE_COMM_FIELDS

    /* Function which will print parameter status */
    /* No need to declare as pointer to code (compiler understood it :-) */
    void (*printer)(void);

    /* Function which will handle parameter change (toggle for example) */
    /* No need to declare as pointer to code (compiler understood it :-) */
    void (*handler)(void);
};
#define ML2MLCB(a) ((const code struct menu_line_cb *)a)
#define INST_MLCB(a,b,c,d,e) \
    const code struct menu_line_cb a = {b,c,d,e}

extern const code struct menu_level * curr_menu;
extern const code struct menu_line * line;

void print_title ();
void PUTS_CODE (const code char *str);
void PUTS_CODE_NL (const code char *str);
void menu (void) reentrant;
void menu_init (void);

extern struct Config configA;
extern struct Config configB;
extern struct CommonConfig configCommon;

extern struct Status statusA;
extern struct Status statusB;
extern struct CommonStatus statusCommon;

#endif //__MENUS_H__
